#include <stdio.h>
#include <curses.h>
#include <math.h>


  WINDOW *wnd;
  int nrows;
  int ncols;

  double a = 0;
  double z = 0;
  double y = 0;
  double x = 0;

  int nr_digits = 1;
  int nr_exp_digits = 0;

  enum input_states {
     INT_PART,
     DEC_PART,
     EXP_PART
  };
  enum input_states state = INT_PART;

/**
 * Clear screen and print values of a,z,y,x registers.
 */
void screen_refresh() {
  char str[22];

  clear();
  printw("+--------------------+\n");
  sprintf(str, "| %+0.10f      |\n", a);
  printw(str);
  sprintf(str, "| %+0.10f      |\n", z);
  printw(str);
  sprintf(str, "| %+0.10f      |\n", y);
  printw(str);
  sprintf(str, "| %+0.10f      |\n", x);
  printw(str);
  printw("+--------------------+");

  move(nrows-1, ncols-1);       // "hide" cursor
} // screen_refresh


err_error() {
  move(4, 0);
  printw("|  invalid input     |\n");
  move(nrows-1, ncols-1);       // "hide" cursor
  getch();
}

fn_sin() {
  x = sin(x);
}

fn_asin() {
  if (x >= -1 && x <= 1) x = asin(x);
  else err_error();
}

fn_pi() {
  x = M_PI;
}

fn_key(int digit) {
  switch(state) {
    case INT_PART: {
      if (nr_digits < 10) {
        x*=10;
        x+=digit;
        nr_digits++;
      }
      break;
    }
/*    case DEC_PART: {*/
/*      if (nr_digits < 10) display_dec++;*/
/*    }*/
/*    case EXP_PART {*/
/*      if (nr_exp_digits < 3) {*/
/*        exp_x*=10;*/
/*        nr_exp_digits++;*/
/*      }*/
/*    }*/
  } // switch
}

fn_enter() {
  a = z;
  z = y;
  y = x;
}

void call(int key) {
  switch(key) {
    case 's': { fn_sin(); break; }
    case 'a': { fn_asin(); break; }
    case 'p': { fn_pi(); break; }
    case '0': { fn_key(0); break; }
    case '1': { fn_key(1); break; }
    case '2': { fn_key(2); break; }
    case '3': { fn_key(3); break; }
    case '4': { fn_key(4); break; }
    case '5': { fn_key(5); break; }
    case '6': { fn_key(6); break; }
    case '7': { fn_key(7); break; }
    case '8': { fn_key(8); break; }
    case '9': { fn_key(9); break; }
    case 10: { fn_enter(); break; }
  } // switch

}


int main(void) {

  char stri[32];

  wnd = initscr();    // initialize curses
  cbreak();           // send keys directly to program
  noecho();           // don't write my typing to screen

  getmaxyx(wnd, nrows, ncols);
  screen_refresh();

  int key = 0;
  do {
    key = getch();

/*    move(10,0);*/
/*    sprintf(stri, "%i", (int)key);*/
/*    printw(stri);*/
/*    getch();*/

    call(key);
    screen_refresh();

  } while (key != 27);    // 27 = escape, most is plain ASCII

  endwin();
  return 0;
} // main
